/*
 * Copyright (c) 1997-1999 Massachusetts Institute of Technology
 * Copyright (c) 2000-2002 Stefan Kral
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/* This file was automatically generated --- DO NOT EDIT */
/* Generated on Tue Feb 19 15:11:14 CET 2002 */

#include <fftw-int.h>
#include <fftw.h>



DECLARE_SIMD_CONST2 (PK1_000000000NK1_000000000, +1.0000000000000000000000000,
		     -1.0000000000000000000000000);
DECLARE_SIMD_CONST2 (PK500000000PK500000000, +0.5000000000000000000000000,
		     +0.5000000000000000000000000);
DECLARE_SIMD_CONST2 (PK866025403PK866025403, +0.8660254037844386467637232,
		     +0.8660254037844386467637232);

void
fftw_twiddle_3 (fftw_complex * ioC, const fftw_complex * twC, int iostride,
		int m, int dist)
{
     fftw_simd2 *inout = (fftw_simd2 *) ioC;
     const fftw_simd2 *W = (const fftw_simd2 *) twC;

     for (; m > 0; m--, inout += dist, W += 2)
       {
	    DECLARE_SIMD_TMPVAR2 (t1061);
	    DECLARE_SIMD_TMPVAR2 (t1062);
	    DECLARE_SIMD_TMPVAR2 (t1060);
	    DECLARE_SIMD_TMPVAR2 (t1058);
	    DECLARE_SIMD_TMPVAR2 (t1059);
	    DECLARE_SIMD_TMPVAR2 (t1075);
	    DECLARE_SIMD_TMPVAR2 (t1074);
	    DECLARE_SIMD_TMPVAR2 (t1034);
	    DECLARE_SIMD_TMPVAR2 (t1047);
	    DECLARE_SIMD_TMPVAR2 (t1048);
	    DECLARE_SIMD_TMPVAR2 (t1046);
	    DECLARE_SIMD_TMPVAR2 (t1044);
	    DECLARE_SIMD_TMPVAR2 (t1045);
	    DECLARE_SIMD_TMPVAR2 (t1073);
	    DECLARE_SIMD_TMPVAR2 (t1072);
	    DECLARE_SIMD_TMPVAR2 (t1033);
	    DECLARE_SIMD_TMPVAR2 (t1069);
	    DECLARE_SIMD_TMPVAR2 (t1032);
	    DECLARE_SIMD_TMPVAR2 (t1031);
	    DECLARE_SIMD_TMPVAR2 (t1030);
	    DECLARE_SIMD_TMPVAR2 (t1064);
	    DECLARE_SIMD_TMPVAR2 (t1070);
	    DECLARE_SIMD_TMPVAR2 (t1063);
	    DECLARE_SIMD_TMPVAR2 (t1071);

	    simd_ld2 (inout[iostride * 2], t1061);
	    simd_swap2 (t1061, t1062);
	    simd_ld2 (W[1], t1060);
	    simd_mul2 (t1060, t1061, t1058);
	    simd_mul2 (t1060, t1062, t1059);
	    simd_unpckL2 (t1058, t1059, t1075);
	    simd_unpckH2 (t1058, t1059, t1074);
	    simd_fnmca2 (PK1_000000000NK1_000000000, t1074, t1075, t1034);
	    simd_ld2 (inout[iostride], t1047);
	    simd_swap2 (t1047, t1048);
	    simd_ld2 (W[0], t1046);
	    simd_mul2 (t1046, t1047, t1044);
	    simd_mul2 (t1046, t1048, t1045);
	    simd_unpckL2 (t1044, t1045, t1073);
	    simd_unpckH2 (t1044, t1045, t1072);
	    simd_fnmca2 (PK1_000000000NK1_000000000, t1072, t1073, t1033);
	    simd_sub2 (t1033, t1034, t1069);
	    simd_add2 (t1033, t1034, t1032);
	    simd_ld2 (inout[0], t1031);
	    simd_add2 (t1031, t1032, t1030);
	    simd_fnmca2 (PK500000000PK500000000, t1032, t1031, t1064);
	    simd_st2 (t1030, inout[0]);
	    simd_swapchsH2 (t1069, t1070);
	    simd_fnmca2 (PK866025403PK866025403, t1070, t1064, t1063);
	    simd_fmca2 (PK866025403PK866025403, t1070, t1064, t1071);
	    simd_st2 (t1063, inout[iostride * 2]);
	    simd_st2 (t1071, inout[iostride]);
       }
}


static const int twiddle_order[] = { 1, 2 };

fftw_codelet_desc fftw_twiddle_3_desc = {
     "fftw_twiddle_3",
     (void (*)()) fftw_twiddle_3,
     3,
     FFTW_FORWARD,
     FFTW_TWIDDLE,
     66,
     2,
     twiddle_order,
};
