type vsimdinstrcategory =
    VSIC_Load
  | VSIC_Store
  | VSIC_UnaryMulConst
  | VSIC_UnaryCopy
  | VSIC_UnarySwap
  | VSIC_UnaryChsLo
  | VSIC_UnaryChsHi
  | VSIC_UnaryChsLoHi
  | VSIC_BinAdd2
  | VSIC_BinSub2
  | VSIC_BinMul2
  | VSIC_BinAcc2
  | VSIC_BinFMcA2
  | VSIC_BinFMcS2
  | VSIC_BinFNMcA2
  | VSIC_BinUnpackL
  | VSIC_BinUnpackH
  | VSIC_BinUnpackLH
  | VSIC_TernFMA2
  | VSIC_TernFMS2
module VSICMap :
  sig
    type key = vsimdinstrcategory
    and +'a t
    val empty : 'a t
    val add : key -> 'a -> 'a t -> 'a t
    val find : key -> 'a t -> 'a
    val remove : key -> 'a t -> 'a t
    val mem : key -> 'a t -> bool
    val iter : (key -> 'a -> unit) -> 'a t -> unit
    val map : ('a -> 'b) -> 'a t -> 'b t
    val mapi : (key -> 'a -> 'b) -> 'a t -> 'b t
    val fold : (key -> 'a -> 'b -> 'b) -> 'a t -> 'b -> 'b
  end
val vsicmap_findE : VSICMap.key -> 'a list VSICMap.t -> 'a list
val vsicmap_addE :
  VSICMap.key -> 'a -> 'a list VSICMap.t -> 'a list VSICMap.t
val vsimdunaryopcategories_chs : vsimdinstrcategory list
val vsimdunaryopcategories_nocopy : vsimdinstrcategory list
val vsimdunaryopcategories_all : vsimdinstrcategory list
val vsimdbinopcategories_par : vsimdinstrcategory list
val vsimdbinopcategories_fmpar : vsimdinstrcategory list
val vsimdbinopcategories_all : vsimdinstrcategory list
val vsimdallcategories : vsimdinstrcategory list
val vsimdchsposToCategory : VSimdBasics.vsimdchspos -> vsimdinstrcategory
val vsimdunaryopToCategory : VSimdBasics.vsimdunaryop -> vsimdinstrcategory
val vsimdbinaryopToCategory : VSimdBasics.vsimdbinaryop -> vsimdinstrcategory
val vsimdternaryopToCategory :
  VSimdBasics.vsimdternaryop -> vsimdinstrcategory
val vsimdinstrToCategory : VSimdBasics.vsimdinstr -> vsimdinstrcategory
val vsimdinstrToCategories :
  VSimdBasics.vsimdinstr -> vsimdinstrcategory list
